﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Collections.ObjectModel;
using KMPP;
using SlimDX.Direct3D9;
using SlimDX;
using System.IO;

namespace DxCapture
{
    public partial class Form1 : Form
    {

        // http://www.codeproject.com/Articles/274461/Very-fast-screen-capture-using-DirectX-in-Csharp

        DxScreenCapture sc = new DxScreenCapture();

        Collection<long> tlPos = new Collection<long>();
        Collection<long> tPos = new Collection<long>();
        Collection<long> trPos = new Collection<long>();
        Collection<long> lPos = new Collection<long>();
        Collection<long> rPos = new Collection<long>();
        Collection<long> blPos = new Collection<long>();
        Collection<long> bPos = new Collection<long>();
        Collection<long> brPos = new Collection<long>();
        const int Bpp = 4;
        DateTime startTime;
        DateTime stopTime;
        TimeSpan duration;
        bool FormIsClosing = false;
        static Surface s;

        public Form1()
        {
            InitializeComponent();

            int o = 20;
            int m = 8;
            int sx = Screen.PrimaryScreen.Bounds.Width - m;
            int sy = Screen.PrimaryScreen.Bounds.Height - m;
            int bx = (sx - m) / 3 + m;
            int by = (sy - m) / 3 + m;
            int bx2 = (sx - m) * 2 / 3 + m;
            int by2 = (sy - m) * 2 / 3 + m;

            long x, y;
            long pos;

            y = m;
            for (x = m; x < sx; x += o)
            {
                pos = (y * Screen.PrimaryScreen.Bounds.Width + x) * Bpp;
                if (x < bx)
                    tlPos.Add(pos);
                else if (x > bx && x < bx2)
                    tPos.Add(pos);
                else if (x > bx2)
                    trPos.Add(pos);
            }

            y = sy;
            for (x = m; x < sx; x += o)
            {
                pos = (y * Screen.PrimaryScreen.Bounds.Width + x) * Bpp;
                if (x < bx)
                    blPos.Add(pos);
                else if (x > bx && x < bx2)
                    bPos.Add(pos);
                else if (x > bx2)
                    brPos.Add(pos);
            }

            x = m;
            for (y = m + 1; y < sy - 1; y += o)
            {
                pos = (y * Screen.PrimaryScreen.Bounds.Width + x) * Bpp;
                if (y < by)
                    tlPos.Add(pos);
                else if (y > by && y < by2)
                    lPos.Add(pos);
                else if (y > by2)
                    blPos.Add(pos);
            }

            x = sx;
            for (y = m + 1; y < sy - 1; y += o)
            {
                pos = (y * Screen.PrimaryScreen.Bounds.Width + x) * Bpp;
                if (y < by)
                    trPos.Add(pos);
                else if (y > by && y < by2)
                    rPos.Add(pos);
                else if (y > by2)
                    brPos.Add(pos);
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
        }

        Color avcs(DataStream gs, Collection<long> positions)
        {
            byte[] bu = new byte[4];
            int r = 0;
            int g = 0;
            int b = 0;
            int i = 0;

            foreach (long pos in positions)
            {
                gs.Position = pos;
                gs.Read(bu, 0, 4);
                r += bu[2];
                g += bu[1];
                b += bu[0];
                i++;
            }

            return Color.FromArgb(r / i, g / i, b / i);
        }

        static bool StreamEquals(Stream stream1, Stream stream2)
        {
            const int bufferSize = 2048;
            byte[] buffer1 = new byte[bufferSize];
            byte[] buffer2 = new byte[bufferSize];
            while (true)
            {
                int count1 = stream1.Read(buffer1, 0, bufferSize);
                int count2 = stream2.Read(buffer2, 0, bufferSize);

                if (count1 != count2)
                    return false;

                if (count1 == 0)
                    return true;

                if (!buffer1.Take(count1).SequenceEqual(buffer2.Take(count2)))
                    return false;
            }
        }

        void Calculate()
        {
            startTime = DateTime.Now;
            s = sc.CaptureScreen();
            stopTime = DateTime.Now;
            duration = stopTime - startTime;
            textBox1.Text = "Capture time: " + Math.Round(duration.TotalMilliseconds).ToString() + " ms";
            Application.DoEvents();
            topRight.BackgroundImageLayout = ImageLayout.Stretch;
            topRight.BackgroundImage = sc.CaptureScreenToBitmap();
            
            //GraphicsStream stream = surface.LockRectangle(LockFlags.None);
            DataRectangle dr = s.LockRectangle(LockFlags.None);
            DataStream gs = dr.Data;
            

            topLeft.BackColor = avcs(gs, tlPos);
            topRight.BackColor = avcs(gs, trPos);
            bottomLeft.BackColor = avcs(gs, blPos);
            bottomRight.BackColor = avcs(gs, brPos);

            top.BackColor = avcs(gs, tPos);
            bottom.BackColor = avcs(gs, bPos);
            left.BackColor = avcs(gs, lPos);
            right.BackColor = avcs(gs, rPos);

            s.UnlockRectangle();
            s.Dispose();
        }

        void Calculate2()
        {
            startTime = DateTime.Now;
            topRight.BackgroundImageLayout = ImageLayout.Stretch;
            topRight.BackgroundImage = sc.CaptureScreenToBitmap();
            stopTime = DateTime.Now;
            duration = stopTime - startTime;
            textBox1.Text = "Capture time: " + Math.Round(duration.TotalMilliseconds).ToString() + " ms";
            Application.DoEvents();
            GC.Collect();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            Calculate();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            while (!this.FormIsClosing) Calculate2();
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            FormIsClosing = true;
        }
    }
}
